import 'package:flutter/material.dart';
import 'package:flutter_livepush_demo/page/home/home_page.dart';
import 'dart:async';
import 'package:flutter_livepush_plugin/live_pusher.dart';
import 'package:flutter_gen/gen_l10n/app_localizations.dart';
import 'common/log_util.dart';

void main() {
  runZoned(() {
    runApp(const MyApp());
  }, onError: (error, stackTrace) {
    LogUtil.v('flutter error: ${error?.toString()}, ${stackTrace?.toString()}');
  });
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();
    LogUtil.init(isDebug: true, tag: 'flutter-livepush');
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: HomePage().buildPage(null),
      localizationsDelegates: AppLocalizations.localizationsDelegates,
      supportedLocales: [
        Locale('en'),
        Locale('zh'),
      ],
    );
  }
}
