import 'package:fish_redux/fish_redux.dart';
import 'package:flutter_livepush_demo/common/CommonUtils.dart';

class InteractiveEnrollmentState
    implements Cloneable<InteractiveEnrollmentState> {
  InteractiveTypeEnum interactiveTypeEnum = InteractiveTypeEnum.interactiveLive;
  InteractiveIdentityTypeEnum interactiveIdentityTypeEnum =
      InteractiveIdentityTypeEnum.anchor;
  String appId = "";
  String appKey = "";
  String playDomain = "";
  bool showAppInfo = false;
  double arrowAngle = 0;
  String userId = "";
  String roomId = "";

  @override
  InteractiveEnrollmentState clone() => InteractiveEnrollmentState()
    ..interactiveTypeEnum = interactiveTypeEnum
    ..interactiveIdentityTypeEnum = interactiveIdentityTypeEnum
    ..appId = appId
    ..appKey = appKey
    ..playDomain = playDomain
    ..showAppInfo = showAppInfo
    ..arrowAngle = arrowAngle
    ..userId = userId
    ..roomId = roomId;
}

InteractiveEnrollmentState initState(Map<String, dynamic> args) {
  InteractiveTypeEnum type;
  if (args[interactiveTypeKey] == InteractiveTypeEnum.interactiveLive.name) {
    type = InteractiveTypeEnum.interactiveLive;
  } else {
    type = InteractiveTypeEnum.interactivePK;
  }
  return InteractiveEnrollmentState()
    ..interactiveTypeEnum = type
    ..appId = args[interactiveAppIdKey] ?? ""
    ..appKey = args[interactiveAppKeyKey] ?? ""
    ..playDomain = args[interactivePlayDomainKey] ?? "";
}
