import 'package:fish_redux/fish_redux.dart';
import 'package:flutter_livepush_demo/common/CommonUtils.dart';

class InteractiveInfoState implements Cloneable<InteractiveInfoState> {
  InteractiveTypeEnum interactiveTypeEnum = InteractiveTypeEnum.interactiveLive;
  String appId = "";
  String appKey = "";
  String playDomain = "";
  bool fromHomePage = true;

  @override
  InteractiveInfoState clone() => InteractiveInfoState()
    ..interactiveTypeEnum = interactiveTypeEnum
    ..appId = appId
    ..appKey = appKey
    ..playDomain = playDomain
    ..fromHomePage = fromHomePage;
}

InteractiveInfoState initState(Map<String, dynamic> args) {
  return InteractiveInfoState()
    ..interactiveTypeEnum = args[interactiveTypeKey]
    ..appId = args[interactiveAppIdKey] ?? ""
    ..appKey = args[interactiveAppKeyKey] ?? ""
    ..playDomain = args[interactivePlayDomainKey] ?? ""
    ..fromHomePage = args[interactiveFromHomePageKey];
}
