import 'package:fish_redux/fish_redux.dart';

enum ConfigAction {
  updateConfigData,
  updatePushURL,
  selectSegmentIndex,
  setLivePushMode,
  setResolution,
  setEnableAutoBitrate,
  setEnableAutoResolution,
  openAdvanced,
  setQualityMode,
  setTargetVideoBitrate,
  setMinVideoBitrate,
  setInitialVideoBitrate,
  setAudioBitrate,
  setMinFps,
  setFps,
  setAudioSampleRate,
  setVideoEncodeGop,
  setAudioEncoderProfile,
  setAudioChannel,
  setAudioEncoderMode,
  setVideoEncoderMode,
  setVideoHardEncoderCodec,
  setOpenBFrame,
  setOrientation,
  setPreviewDisplayMode,
  setConnectRetryInterval,
  setConnectRetryCount,
  setPushMirror,
  setPreviewMirror,
  setCameraType,
  setAutoFocus,
  setBeautyOn,
  setPauseImg,
  setNetworkPoorImg,
  setPushStreamingMode,
  openLog,
  goBackPage,
  clickPushPage,
}

class ConfigActionCreator {
  static Action updateConfigData(ConfigDataUpdatePayload payload) =>
      Action(ConfigAction.updateConfigData, payload: payload);
  static Action setLivePushMode(newValue) =>
      Action(ConfigAction.setLivePushMode, payload: newValue);
  static Action setResolution(newValue) =>
      Action(ConfigAction.setResolution, payload: newValue);
  static Action setEnableAutoBitrate(newValue) =>
      Action(ConfigAction.setEnableAutoBitrate, payload: newValue);
  static Action setEnableAutoResolution(newValue) =>
      Action(ConfigAction.setEnableAutoResolution, payload: newValue);
  static Action setQualityMode(newValue) =>
      Action(ConfigAction.setQualityMode, payload: newValue);
  static Action setTargetVideoBitrate(newValue) =>
      Action(ConfigAction.setTargetVideoBitrate, payload: newValue);
  static Action setMinVideoBitrate(newValue) =>
      Action(ConfigAction.setMinVideoBitrate, payload: newValue);
  static Action setInitialVideoBitrate(newValue) =>
      Action(ConfigAction.setInitialVideoBitrate, payload: newValue);
  static Action setAudioBitrate(newValue) =>
      Action(ConfigAction.setAudioBitrate, payload: newValue);
  static Action setMinFps(newValue) =>
      Action(ConfigAction.setMinFps, payload: newValue);
  static Action setFps(newValue) =>
      Action(ConfigAction.setFps, payload: newValue);
  static Action setAudioSampleRate(newValue) =>
      Action(ConfigAction.setAudioSampleRate, payload: newValue);
  static Action setVideoEncodeGop(newValue) =>
      Action(ConfigAction.setVideoEncodeGop, payload: newValue);
  static Action setAudioEncoderProfile(newValue) =>
      Action(ConfigAction.setAudioEncoderProfile, payload: newValue);
  static Action setAudioChannel(newValue) =>
      Action(ConfigAction.setAudioChannel, payload: newValue);
  static Action setAudioEncoderMode(newValue) =>
      Action(ConfigAction.setAudioEncoderMode, payload: newValue);
  static Action setVideoEncoderMode(newValue) =>
      Action(ConfigAction.setVideoEncoderMode, payload: newValue);
  static Action setVideoHardEncoderCodec(newValue) =>
      Action(ConfigAction.setVideoHardEncoderCodec, payload: newValue);
  static Action setOpenBFrame(newValue) =>
      Action(ConfigAction.setOpenBFrame, payload: newValue);
  static Action setOrientation(newValue) =>
      Action(ConfigAction.setOrientation, payload: newValue);
  static Action setPreviewDisplayMode(newValue) =>
      Action(ConfigAction.setPreviewDisplayMode, payload: newValue);
  static Action setConnectRetryInterval(newValue) =>
      Action(ConfigAction.setConnectRetryInterval, payload: newValue);
  static Action setConnectRetryCount(newValue) =>
      Action(ConfigAction.setConnectRetryCount, payload: newValue);
  static Action setPushMirror(newValue) =>
      Action(ConfigAction.setPushMirror, payload: newValue);
  static Action setPreviewMirror(newValue) =>
      Action(ConfigAction.setPreviewMirror, payload: newValue);
  static Action setCameraType(newValue) =>
      Action(ConfigAction.setCameraType, payload: newValue);
  static Action setAutoFocus(newValue) =>
      Action(ConfigAction.setAutoFocus, payload: newValue);
  static Action setBeautyOn(newValue) =>
      Action(ConfigAction.setBeautyOn, payload: newValue);
  static Action setPauseImg(newValue) =>
      Action(ConfigAction.setPauseImg, payload: newValue);
  static Action setNetworkPoorImg(newValue) =>
      Action(ConfigAction.setNetworkPoorImg, payload: newValue);
  static Action setPushStreamingMode(newValue) =>
      Action(ConfigAction.setPushStreamingMode, payload: newValue);
  static Action openLog(newValue) =>
      Action(ConfigAction.openLog, payload: newValue);
  static Action goBackPage() => const Action(ConfigAction.goBackPage);
  static Action clickPushPage(String? url) =>
      Action(ConfigAction.clickPushPage, payload: url);
}

class ConfigDataUpdatePayload {
  ConfigAction actionType = ConfigAction.updateConfigData;
  dynamic value;

  static ConfigDataUpdatePayload create(
      ConfigAction actionType, dynamic value) {
    ConfigDataUpdatePayload payload = ConfigDataUpdatePayload();
    payload.actionType = actionType;
    payload.value = value;
    return payload;
  }
}
