import 'package:fish_redux/fish_redux.dart';
import 'package:flutter_livepush_demo/common/CommonUtils.dart';
import 'package:flutter_livepush_demo/manager/push_config_manager.dart';
import 'package:flutter_livepush_plugin/interactive/live_player_config.dart';
import 'package:flutter_livepush_plugin/live_push_config.dart';

typedef OnSettingConfigAction = void Function(
    AlivcLivePusherConfig pusherConfig);

class ConfigState implements Cloneable<ConfigState> {
  ConfigData configData = ConfigData();
  PushConfigPageType pageType = PushConfigPageType.basic;
  OnSettingConfigAction? onSettingConfigAction;

  @override
  ConfigState clone() => ConfigState()
    ..configData = configData
    ..pageType = pageType
    ..onSettingConfigAction = onSettingConfigAction;
}

ConfigState initState(Map<String, dynamic> args) {
  return ConfigState()
    ..configData
    ..pageType = args[pushConfigPageTypeKey]
    ..onSettingConfigAction = args[pushConfigOnSettingConfigActionKey];
}
